define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for DistribucionOrdenes generated by Appery.io
         * @module DistribucionOrdenes
         */
        APP.controller('DistribucionOrdenes', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.ordenesTotal = Apperyio.EntityAPI('Number');
            $scope.orders = Apperyio.EntityAPI('Ordenes');
            $scope.codigoBuscar = Apperyio.EntityAPI('String');
            $scope.marcaBuscar = Apperyio.EntityAPI('String');
            $scope.estadoBuscar = Apperyio.EntityAPI('String');
            $scope.operadorBuscar = Apperyio.EntityAPI('String');
            $scope.markers = Apperyio.EntityAPI('Markers');
            $scope.ordenesBloques = Apperyio.EntityAPI('Ordenes');
            $scope.estadoOp = Apperyio.EntityAPI('listaEstadosOperacion');
            /**
             * User controller functions
             */
            /**
             * @function init
             * @param fechaAsignacion
             */
            $scope.init = function(fechaAsignacion) {
                //On load screen logic
                $scope.minFechaSelect = formatDateNow2($scope.diasSeleccionCalendarioRetro);
                $scope.orders = [];
                $scope.ordenesTotal = $scope.orders.length;
                $scope.mostrarMapa = false;
                $scope.textoBotnVerMapa = "Mostrar Mapa";
                $scope.markers = [];
                $scope.fechaAsignacionData = fechaAsignacion ? formatDate3(fechaAsignacion.toISOString()) : formatDateNow2(0);
                $scope.fechaAsignacionGlobal = fechaAsignacion;
                $scope.datosEmpresa = JSON.parse(localStorage.getItem("companyData"));
                $scope.estadoOp = JSON.parse(localStorage.getItem("diasOperacion"));
                $scope.mOperators = localStorage.getItem("arrayOperators") ? JSON.parse(localStorage.getItem("arrayOperators")) : [];
                $scope.ordenesBloques = [];
                $scope.diaNoEditable = true;
                $scope.diaNoEditable = false;
                for (var i in $scope.estadoOp) {
                    if ($scope.estadoOp[i].fecha == ($scope.fechaAsignacionModel ? formatDate3($scope.fechaAsignacionModel.toISOString()) : formatDateNow2(0))) {
                        $scope.diaNoEditable = true;
                        break;
                    }
                }
                $scope.showLoading();
                //Separamos las órdenes dentro del objeto por operador
                var requestData = {};
                requestData = (function mapping5211($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "companyId": $scope.datosEmpresa.idCliente
                            },
                            ($scope.fechaAsignacionModel) ? {
                                "assignmentDate": formatDate3($scope.fechaAsignacionModel.toISOString())
                            } : {
                                "assignmentDate": formatDateNow2(0)
                            },
                        ]
                    };
                    requestData.params.limit = 300;
                    return requestData;
                    /*|button_mapping|onbeforesend|CDF6683C-5833-D021-8627-E23BE397CDEA||5211|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_query_service")(requestData).then( /*|service_bookmark|bookmark|CDF6683C-5833-D021-8627-E23BE397CDEA||9415|*/
                    function(success) { // success callback
                        (function mapping3777(success, $scope) {
                            var ordenesBloques_scope = $scope.ordenesBloques;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(ordenesBloques_scope, '[' + i + '].codigo', success.data[i].documentCode);
                                _.set(ordenesBloques_scope, '[' + i + '].estado', success.data[i].documentStatus);
                                _.set(ordenesBloques_scope, '[' + i + '].enDispositivo', success.data[i].deviceData.enDispositivo);
                                _.set(ordenesBloques_scope, '[' + i + '].tipoServicio', success.data[i].formType);
                                _.set(ordenesBloques_scope, '[' + i + '].subTipoServicio', success.data[i].formSubType);
                                //            _.set(ordenesBloques_scope, '[' + i + '].fechaEstimada', success.data[i].fechaEstimada);
                                //            _.set(ordenesBloques_scope, '[' + i + '].comentarioCierre', success.data[i].operationData.additionalData.statusEndDocument.endCode + "-" + success.data[i].operationData.additionalData.statusEndDocument.endMesssage + (success.data[i].operationData.additionalData.statusEndDocument.addText?" " + success.data[i].operationData.additionalData.statusEndDocument.addText:""));
                                if (success.data[i].documentStatus > 3 && success.data[i].operationData.additionalData.statusEndDocument.endCode) {
                                    _.set(ordenesBloques_scope, '[' + i + '].comentarioCierre', success.data[i].operationData.additionalData.statusEndDocument.endCode + "-" + success.data[i].operationData.additionalData.statusEndDocument.endMessage + (success.data[i].operationData.additionalData.statusEndDocument.addText ? " " + success.data[i].operationData.additionalData.statusEndDocument.addText : ""));
                                } else {
                                    _.set(ordenesBloques_scope, '[' + i + '].comentarioCierre', "");
                                }
                                //            _.set(ordenesBloques_scope, '[' + i + '].tipoCancelacion', success.data[i].tipoCancelacion);
                                _.set(ordenesBloques_scope, '[' + i + '].ingeniero', success.data[i].operatorCode);
                                _.set(ordenesBloques_scope, '[' + i + '].mark', success.data[i].assignmentLocation);
                                if (ordenesBloques_scope[i].mark) {
                                    ordenesBloques_scope[i].mark.options = $scope.stateList[success.data[i].documentStatus].optionsLocation;
                                }
                                _.set(ordenesBloques_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(ordenesBloques_scope, '[' + i + '].color', $scope.stateList[success.data[i].documentStatus].color);
                                _.set(ordenesBloques_scope, '[' + i + '].colorExistePosGPS', success.data[i].assignmentLocation ? "default" : "danger");
                                _.set(ordenesBloques_scope, '[' + i + '].msgNoPosGPS', success.data[i].assignmentLocation ? "" : " (POSICION GPS NO DETERMINADA)");
                                _.set(ordenesBloques_scope, '[' + i + '].receiverAntecedent', success.data[i].receiverAntecedent);
                                _.set(ordenesBloques_scope, '[' + i + '].receiverContact', success.data[i].receiverContact);
                                _.set(ordenesBloques_scope, '[' + i + '].previousDiagnosis', success.data[i].previousDiagnosis);
                                _.set(ordenesBloques_scope, '[' + i + '].productAntecedent', success.data[i].productAntecedent);
                                _.set(ordenesBloques_scope, '[' + i + '].serviceAntecedent', success.data[i].serviceAntecedent);
                                _.set(ordenesBloques_scope, '[' + i + '].operationData', success.data[i].operationData);
                                //Agregamos las columnas dinámicas por cada orden
                                ordenesBloques_scope[i].columnValues = [];
                                ordenesBloques_scope[i].columnNames = [];
                                if ($scope.datosEmpresa.config.dataViewDistribution) {
                                    for (var j in $scope.datosEmpresa.config.dataViewDistribution) {
                                        e = $scope.datosEmpresa.config.dataViewDistribution[j];
                                        var a = null;
                                        eval("a = ordenesBloques_scope[" + i + "]." + e.array);
                                        if (a) {
                                            for (var k in a) {
                                                if (e.names.includes(a[k][e.key])) {
                                                    ordenesBloques_scope[i].columnValues.push(a[k][e.value]);
                                                    ordenesBloques_scope[i].columnNames.push(a[k][e.key]);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            $scope.ordenesBloques = ordenesBloques_scope;
                            /*|button_mapping|onsuccess|CDF6683C-5833-D021-8627-E23BE397CDEA||3777|*/
                        })(success, $scope);
                        for (var i in $scope.mOperators) {
                            $scope.mOperators[i].cantOrdenes = 0;
                            $scope.mOperators[i].ordenes = [];
                            $scope.mOperators[i].pos = i;
                            $scope.mOperators[i].mapCtrl = {
                                latitude: -33.502113,
                                longitude: -70.693409,
                                zoom: 11
                            };
                            for (var j in $scope.ordenesBloques) {
                                if ($scope.mOperators[i].codigo == $scope.ordenesBloques[j].ingeniero) {
                                    $scope.ordenesBloques[j].tieneOperador = true;
                                    if ($scope.ordenesBloques[j].tipoCancelacion) {
                                        mTextoComentario = $scope.ordenesBloques[j].comentarioCierre ? "(" + $scope.ordenesBloques[j].comentarioCierre + ")" : ""
                                    } else {
                                        mTextoComentario = "";
                                    }
                                    $scope.mOperators[i].cantOrdenes++;
                                    $scope.mOperators[i].ordenes.push({
                                        codigo: $scope.ordenesBloques[j].codigo,
                                        comuna: $scope.ordenesBloques[j].comuna,
                                        enDispositivo: $scope.ordenesBloques[j].enDispositivo,
                                        tipoServicio: $scope.ordenesBloques[j].tipoServicio,
                                        tipoCancelacion: $scope.ordenesBloques[j].tipoCancelacion,
                                        comentarioCierre: $scope.ordenesBloques[j].comentarioCierre,
                                        ordenNoEditable: $scope.ordenesBloques[j].estado != 1 ? true : false,
                                        ordenEliminable: $scope.ordenesBloques[j].estado == 1 || ($scope.ordenesBloques[j].estado == 2 && !$scope.ordenesBloques[j].enDispositivo) ? true : false,
                                        ordenReasignable: $scope.ordenesBloques[j].estado == 2 || $scope.ordenesBloques[j].estado >= 5 ? true : false,
                                        tipoCancelacionShow: ($scope.ordenesBloques[j].tipoCancelacion == "C" || $scope.ordenesBloques[j].tipoCancelacion == "P") && $scope.ordenesBloques[j].estado != 1 ? false : true,
                                        subTipoServicio: $scope.ordenesBloques[j].subTipoServicio,
                                        fechaEstimada: $scope.ordenesBloques[j].fechaEstimada,
                                        mark: $scope.ordenesBloques[j].mark,
                                        color: $scope.ordenesBloques[j].color,
                                        _id: $scope.ordenesBloques[j]._id,
                                        textoComentario: mTextoComentario,
                                        typeColor: $scope.ordenesBloques[j].estado >= 5 ? "success" : "warning",
                                        colorExistePosGPS: $scope.ordenesBloques[j].colorExistePosGPS,
                                        msgNoPosGPS: $scope.ordenesBloques[j].msgNoPosGPS,
                                        columnValues: $scope.ordenesBloques[j].columnValues
                                    })
                                }
                            }
                            $scope.mOperators[i].showMap = $scope.mOperators[i].cantOrdenes > 0 ? true : false;
                        }
                        //Busco las órdenes huérfanas
                        $scope.ordersNotAssign = [];
                        for (var j in $scope.ordenesBloques) {
                            if (!$scope.ordenesBloques[j].tieneOperador) {
                                $scope.ordersNotAssign.push({
                                    "codigo": $scope.ordenesBloques[j].codigo,
                                    "_id": $scope.ordenesBloques[j]._id
                                });
                            }
                        }
                        $scope.stopLoading();
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al recuperar las órdenes: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
                //$scope.estadoOp
            };
            /**
             * @function descargar
             */
            $scope.descargar = function() {
                tableToExcel('dataTable', 'Ordenes');
            };
            /**
             * @function formatDate1
             * @param fecha
             */
            function formatDate1(fecha) {
                if (!fecha) {
                    return fecha;
                }
                var arrFecha = fecha.split(".");
                return arrFecha[2] + "-" + arrFecha[0] + "-" + arrFecha[1];
            };
            /**
             * @function buscarOrdenes
             */
            $scope.buscarOrdenes = function() {
                $scope.orders = [];
                $scope.ordenesTotal = $scope.orders.length;
                $scope.markers = [];
                var requestData = {};
                requestData = (function mapping9688($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [
                            ($scope.codigoBuscar) ? {
                                "codigo": $scope.codigoBuscar
                            } : {},
                            ($scope.marcaBuscar != "0" && $scope.marcaBuscar != "") ? {
                                "marca": $scope.marcaBuscar
                            } : {},
                            ($scope.estadoBuscar != "0" && $scope.estadoBuscar != "") ? {
                                "estado": $scope.estadoBuscar
                            } : {},
                            ($scope.operadorBuscar != "0" && $scope.operadorBuscar != "") ? {
                                "idOperador": $scope.operadorBuscar
                            } : {},
                        ]
                    };
                    return requestData;
                    /*|button_mapping|onbeforesend|0C90AEF2-D0C1-6BDD-C408-473C557EE902||9688|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_ORDERS_query_service")(requestData).then( /*|service_bookmark|bookmark|0C90AEF2-D0C1-6BDD-C408-473C557EE902||3904|*/
                    function(success) { // success callback
                        (function mapping1876(success, $scope) {
                            var orders_scope = $scope.orders;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(orders_scope, '[' + i + '].codigo', success.data[i].codigo);
                                _.set(orders_scope, '[' + i + '].estado', success.data[i].estado);
                                _.set(orders_scope, '[' + i + '].marca', success.data[i].marca);
                                _.set(orders_scope, '[' + i + '].cliente', success.data[i].nombreCliente);
                                _.set(orders_scope, '[' + i + '].fechaSolicitud', success.data[i].fechaAsignacion);
                                _.set(orders_scope, '[' + i + '].comuna', success.data[i].comuna);
                                _.set(orders_scope, '[' + i + '].ingeniero', success.data[i].idOperador);
                                _.set(orders_scope, '[' + i + '].tipoServicio', success.data[i].tipoServicio);
                                _.set(orders_scope, '[' + i + '].subTipoServicio', success.data[i].subTipoServicio);
                                _.set(orders_scope, '[' + i + '].fechaCompra', success.data[i].fechaCompra);
                                _.set(orders_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(orders_scope, '[' + i + '].posGpsFinServicio', success.data[i].posGpsFinServicio);
                                imarker = JSON.parse(success.data[i].posGpsFinServicio);
                                $scope.markers.push(imarker);
                            }
                            $scope.orders = orders_scope;
                            /*|button_mapping|onsuccess|0C90AEF2-D0C1-6BDD-C408-473C557EE902||1876|*/
                            $scope.ordenesTotal = $scope.orders.length
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function verFicha
             * @param orden
             */
            $scope.verFicha = function(orden) {
                Apperyio.get('userManager').orderId = orden;
                Apperyio.navigateTo("FichaOrden");
            };
            /**
             * @function mostrarMapaEnPantalla
             */
            $scope.mostrarMapaEnPantalla = function() {
                $scope.mostrarMapa = !$scope.mostrarMapa;
                if ($scope.mostrarMapa)
                    $scope.textoBotnVerMapa = "Ocultar Mapa";
                else
                    $scope.textoBotnVerMapa = "Mostrar Mapa";
            };
            /**
             * @function showmsg
             */
            $scope.showmsg = function() {
                alert(1);
            };
            /**
             * @function formatDateNow2
             * @param dias
             */
            function formatDateNow2(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                var dd = today.getDate();
                var mm = today.getMonth() + 1;
                var yyyy = today.getFullYear();
                return yyyy + '-' + $scope.addZero(mm) + '-' + addZero(dd);
            };
            /**
             * @function formatDate3
             * @param dat
             */
            function formatDate3(dat) {
                var fecha = dat.split("T");
                return fecha[0];
            };
            /**
             * @function reasignarFecha
             * @param orden
             * @param fecha
             */
            $scope.reasignarFecha = function(orden, fecha) {
                //Por defecto siempre se mueve en estado CREADA
                var estadoMover = 1;
                //Validar que no se aplique a un día asignado
                if (existeFechaProceso($scope.estadoOp, formatDate3(fecha.toISOString()))) {
                    if ($scope.mConfirm("La fecha a la que está intentando mover la orden ya está procesada. Desea mover la orden de todas maneras")) {
                        //La orden llega al día cerrado en estado lista para descarga
                        estadoMover = 2;
                    } else {
                        //Buscar el modelo para devolver la fecha
                        for (var j in $scope.mOperators) {
                            for (var k in $scope.mOperators[j].ordenes) {
                                if ($scope.mOperators[j].ordenes[k]._id == orden) {
                                    $scope.mOperators[j].ordenes[k].fechaAsignacionModel = $scope.fechaAsignacionGlobal ? $scope.fechaAsignacionGlobal : formData5(1);
                                    break;
                                }
                            }
                        }
                        return;
                    }
                }
                var requestData = {};
                requestData = (function mapping8756($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.data = {};
                    requestData.params._id = orden;
                    _.set(requestData.data, 'documentStatus', estadoMover);
                    _.set(requestData.data, 'deviceData.enDispositivo', false);
                    _.set(requestData.data, 'assignmentDate', formatDate3(fecha.toISOString()));
                    return requestData;
                    /*|button_mapping|onbeforesend|6E5E699F-A8D9-A45D-04D1-BA32151C751D||8756|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_update_service")(requestData).then( /*|service_bookmark|bookmark|6E5E699F-A8D9-A45D-04D1-BA32151C751D||5129|*/
                    function(success) { // success callback
                        /*|button_mapping|onsuccess|6E5E699F-A8D9-A45D-04D1-BA32151C751D||9688|*/
                        //Buscar el modelo para eliminar el registro
                        for (var j in $scope.mOperators) {
                            for (var k in $scope.mOperators[j].ordenes) {
                                if ($scope.mOperators[j].ordenes[k]._id == orden) {
                                    $scope.mOperators[j].ordenes.splice(k, 1);
                                    break;
                                }
                            }
                        }
                    },
                    function(error) { // callback to handle request error
                        $scope.mAlert("Hubo errores al mover la orden: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function distribuirDia
             */
            $scope.distribuirDia = function() {
                if ($scope.mConfirm("Esta acción asignará el trabajo a los operadores y no podrá deshacerse.\n¿Desea continuar?")) {
                    var listaCodigosUpdate = [];
                    //Armar el arreglo de códigos de ordenes
                    for (var j in $scope.mOperators) {
                        for (var k in $scope.mOperators[j].ordenes) {
                            listaCodigosUpdate.push($scope.mOperators[j].ordenes[k]._id);
                        }
                    }
                    $scope.showLoading("Actualizando...");
                    //Cambiar el estado de las órdenes del día distribuido vía ServerCode
                    var requestData = {};
                    requestData = (function mapping1733($scope) {
                        var requestData = {};
                        requestData.params = {};
                        requestData.params.listaCodigos = JSON.stringify(listaCodigosUpdate);
                        requestData.params.idEmpresa = $scope.datosEmpresa.idCliente;
                        requestData.params.fecha = $scope.fechaAsignacionGlobal ? formatDate3($scope.fechaAsignacionGlobal.toISOString()) : formatDateNow2(0);
                        return requestData;
                        /*|button_mapping|onbeforesend|FE72B83E-77CE-792A-B18B-75876E6767BE||1733|*/
                    })($scope);
                    // read more about using rest services: https://links.appery.io/ve-snippet-rest
                    Apperyio.get("updateMassiveOrdersState_service")(requestData).then( /*|service_bookmark|bookmark|FE72B83E-77CE-792A-B18B-75876E6767BE||8772|*/
                        function(success) { // success callback
                            /*|button_mapping|onbeforesend|5E7AC57C-46EB-4023-DEBE-4C461EF2DE9F||6297|*/
                            //Actualizar la lista de días de operación
                            $scope.estadoOp.push({
                                estado: true,
                                fecha: $scope.fechaAsignacionGlobal ? formatDate3($scope.fechaAsignacionGlobal.toISOString()) : formatDateNow2(0)
                            });
                            localStorage.setItem("diasOperacion", JSON.stringify($scope.estadoOp));
                            $scope.stopLoading();
                            $scope.diaNoEditable = true;
                            $scope.init($scope.fechaAsignacionGlobal);
                        },
                        function(error) { // callback to handle request error
                            $scope.stopLoading();
                            $scope.mAlert("Hubo errores al cerrar el día: " + error.data.code + " " + error.data.description);
                        },
                        function(notify) { // notify callback, can fire few times
                        });
                }
            };
            /**
             * @function formDate4
             * @param fecha
             */
            function formDate4(fecha) {
                if (!fecha)
                    return fecha;
                var arrFecha = fecha.split(" ");
                var a1 = arrFecha[0];
                var a1Arr = a1.split("-");
                return new Date(a1Arr[0], a1Arr[1] - 1, a1Arr[2]);
            };
            /**
             * @function formData5
             * @param dias
             */
            function formData5(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                return today;
            };
            /**
             * @function goToDistOperator
             * @param operatorId
             * @param operatorName
             * @param fechaModel
             */
            $scope.goToDistOperator = function(operatorId, operatorName, fechaModel) {
                Apperyio.get('userManager').operatorId = operatorId;
                Apperyio.get('userManager').operatorName = operatorName;
                Apperyio.navigateTo("DistribucionOrdenesOperador", {});
            };
            /**
             * @function existeFechaProceso
             * @param arregloDias
             * @param fecha
             */
            function existeFechaProceso(arregloDias, fecha) {
                for (var i in arregloDias)
                    if (arregloDias[i].fecha == fecha)
                        return true;
                return false;
            };
            /**
             * @function setCenterMap
             * @param elem
             * @param mark
             * @param zoom
             */
            $scope.setCenterMap = function(elem, mark, zoom) {
                $scope.mOperators[elem].mapCtrl.latitude = mark.latitude;
                $scope.mOperators[elem].mapCtrl.longitude = mark.longitude;
                $scope.mOperators[elem].mapCtrl.zoom = zoom;
            };
            /**
             * @function reasignarFechaCancel
             * @param id
             * @param orden
             * @param elemOp
             */
            $scope.reasignarFechaCancel = function(id, orden, elemOp) {
                if ($scope.mConfirm("Ud. va a modificar la fecha de asignación para la orden " + orden + ". \n¿Desea continuar?")) {
                    //Buscamos en el arreglo de operadores el elemento
                    for (var i in $scope.mOperators[elemOp].ordenes) {
                        if ($scope.mOperators[elemOp].ordenes[i]._id == id) {
                            $scope.mOperators[elemOp].ordenes[i].tipoCancelacionShow = true;
                            $scope.mOperators[elemOp].ordenes[i].ordenNoEditable = false;
                            break;
                        }
                    }
                }
            };
            /**
             * @function reasignarFechaAssign
             * @param id
             * @param orden
             * @param elemOp
             * @param enDisp
             */
            $scope.reasignarFechaAssign = function(id, orden, elemOp, enDisp) {
                if (enDisp) {
                    if ($scope.mConfirm("Ud. va a reasignar la orden " + orden + " que está en la bandeja de trabajo de " + $scope.mOperators[elemOp].nombre + ". \n¿Desea continuar?")) {
                        //Buscamos en el arreglo de operadores el elemento
                        for (var i in $scope.mOperators[elemOp].ordenes) {
                            if ($scope.mOperators[elemOp].ordenes[i]._id == id) {
                                $scope.mOperators[elemOp].ordenes[i].ordenNoEditable = false;
                                break;
                            }
                        }
                    }
                } else {
                    for (var i in $scope.mOperators[elemOp].ordenes) {
                        if ($scope.mOperators[elemOp].ordenes[i]._id == id) {
                            $scope.mOperators[elemOp].ordenes[i].ordenNoEditable = false;
                            break;
                        }
                    }
                }
            };
            /**
             * @function eliminarOrden
             * @param id
             * @param codigo
             * @param elemOp
             */
            $scope.eliminarOrden = function(id, codigo, elemOp) {
                if ($scope.mConfirm("¿Desea eliminar del sistema la orden " + codigo + "?")) {
                    var requestData = {};
                    requestData = (function mapping2657($scope) {
                        var requestData = {};
                        requestData.params = {};
                        requestData.params._id = id;
                        return requestData;
                        /*|button_mapping|onbeforesend|DFF0B5F8-D301-0BED-BC0A-4A114A66DA4D||2657|*/
                    })($scope);
                    // read more about using rest services: https://links.appery.io/ve-snippet-rest
                    Apperyio.get("Tech1_WORKORDER_delete_service")(requestData).then( /*|service_bookmark|bookmark|DFF0B5F8-D301-0BED-BC0A-4A114A66DA4D||4144|*/
                        function(success) { // success callback
                            /*|button_mapping|onsuccess|DFF0B5F8-D301-0BED-BC0A-4A114A66DA4D||5463|*/
                            //Busco la orden en el arreglo y la elimino
                            for (var j in $scope.mOperators) {
                                for (var k in $scope.mOperators[j].ordenes) {
                                    if ($scope.mOperators[j].ordenes[k]._id == id) {
                                        $scope.mOperators[j].ordenes.splice(k, 1);
                                        break;
                                    }
                                }
                            }
                        },
                        function(error) { // callback to handle request error
                        },
                        function(notify) { // notify callback, can fire few times
                        });
                }
            };
        }
    });